import { custTypeFindAllList } from '@/api/custType'
const custType = {
  template: `
      <a-select
        :placeholder="placeholder"
        :id="id"
        allowClear
        :value="defaultVal"
        :showSearch="true"
        @change="handleChange"
        option-filter-prop="children"
        :dropdownMatchSelectWidth="false"
        :filter-option="filterOption">
        <a-select-option v-for="item in list" :pinyin="item.pinyin" :key="item.customerTypeSn" :value="item.customerTypeSn">{{ item.name }}</a-select-option>
      </a-select>
    `,
  props: {
    value: {
      type: String,
    },
    id: {
      type: String,
      default: ''
    },
    placeholder: {
      type: String,
      default: '请选择客户类型'
    }
  },
  data() {
    return {
      defaultVal: this.value,
      list: []
    };
  },
  mounted() {
    this.getList()
  },
  watch: {
    value(newValue, oldValue) {
      this.defaultVal = newValue
    }
  },
  methods: {
    filterOption (input, option) {
      return (
        option.componentOptions.children[0].text.toLowerCase().indexOf(input.toLowerCase()) >= 0 || 
        option.data.attrs.pinyin.toLowerCase().indexOf(input.toLowerCase()) >= 0
      )
    },
    handleChange(value) {
      this.defaultVal = value;
      this.$emit('change', value);
      this.$emit('input', value);
    },
    getList () {
      custTypeFindAllList().then(res => {
        if (res.status == 200) {
          this.list = res.data
        } else {
          this.list = []
        }
      })
    },
  },
};

export default custType